Subject: bug#23024: ls output quoting (when using --dired switch)

From: Pádraig Brady <[email-masked]>
Date: Wed, 28 Sep 2016 21:23:47 +0100

On 16/03/16 17:07, Pádraig Brady wrote:
> On 15/03/16 23:35, Daniel Lopez wrote:
>> Hi,
>>
>> The recent change to the default way that ls renders filenames with
>> spaces in (now surrounding them in single quotes) is also happening in
>> the presence of this switch:
>>
>>     -D, --dired                generate output designed for Emacs' dired mode
>>
>> and it's correspondingly breaking Emacs' dired mode in some
>> circumstances. Specifically, it's affecting me when I use dired in Emacs
>> to browse files on a remote machine through Emacs' 'Tramp' feature. The
>> spaced/quoted files and directories can't be opened or navigated into.
>>
>> Test case:
>> - Start Emacs (I'm using the current stable version 24.5.1)
>> - Find file (C-x C-f) and enter "/ssh:localhost:" (since I'm using
>> localhost as an example, you'll need to have a local SSH server running)
>> - Notice that files or directories with spaces in the name are
>> surrounded in quotes, and can't be opened (by putting the cursor on them
>> and pressing return)
>>
>> Whatever one thinks of the default change in general (I disapprove,
>> myself; I find the intermittently-appearing quotes disturbing the
>> alignment in an "ls -l" and disrupting my flow as a human reader),
>> perhaps it should be done in a way that does not disturb other use cases
>> that ls also explicitly claims to support.
> 
> Right, we shouldn't mess with quoting in --dired mode.
> I'll fix it up shortly.

On further analysis I see that --dired mode already distinguishes
the quoting-style in its output.  Also we had already documented
that --dired should specify a --quoting-style to get consistent output.
Also this looks to have been fixed already in emacs:
https://github.com/emacs-mirror/emacs/commit/e4adb6

That handles all cases as well as users having QUOTING_STYLE
set in their environment with versions of ls prior to 8.24.

Therefore I'm inclined to leave this behavior as is.

thanks,
Pádraig